#include "launchelf.h"

LANGUAGE *lang;

//-------------------------------------------------
void InitLanguage(void)
{
	lang = (LANGUAGE*)malloc(sizeof(LANGUAGE));
	SetLanguage(LANG_ENGLISH);
}

//-------------------------------------------------
void FreeLanguage(void)
{
	free(lang);
}

//-------------------------------------------------
void SetLanguage(const int langID)
{
	int l;

	l=langID;
	if(l<LANG_ENGLISH) l=LANG_ENGLISH;
	if(l>=NUM_LANG) l=LANG_ENGLISH;
	memset(lang, 0, sizeof(LANGUAGE));

	if(l==LANG_ENGLISH){
		//general
		strcpy(lang->gen_ok, "OK");
		strcpy(lang->gen_cancel, "CANCEL");
		//main
		{
		strcpy(lang->main_launch_hint, "PUSH ANY BUTTON or D-PAD!");
		strcpy(lang->main_loadhddmod, "Loading HDD Modules...");
		strcpy(lang->main_loadftpmod, "Loading FTP Modules...");
		strcpy(lang->main_notfound, " is Not Found.");
		strcpy(lang->main_readsystemcnf, "Reading SYSTEM.CNF...");
		strcpy(lang->main_failed, "Failed");
		strcpy(lang->main_nodisc, "No Disc");
		strcpy(lang->main_detectingdisc, "Detecting Disc");
		strcpy(lang->main_stopdisc, "Stop Disc");
		}
		//filer
		{
		strcpy(lang->filer_menu_copy, "Copy");
		strcpy(lang->filer_menu_cut, "Cut");
		strcpy(lang->filer_menu_paste, "Paste");
		strcpy(lang->filer_menu_delete, "Delete");
		strcpy(lang->filer_menu_rename, "Rename");
		strcpy(lang->filer_menu_newdir, "New Dir");
		strcpy(lang->filer_menu_getsize, "Get Size");
		strcpy(lang->filer_menu_exportpsu, "Export psu");
		strcpy(lang->filer_menu_importpsu, "Import psu");
		strcpy(lang->filer_overwrite, "Overwrite?");
		strcpy(lang->filer_not_elf, "This file isn't ELF.");
		strcpy(lang->filer_not_fnt, "This file isn't FNT.");
		strcpy(lang->filer_copy_to_clip, "Copied to the Clipboard");
		strcpy(lang->filer_delete, "Delete?");
		strcpy(lang->filer_deletemarkfiles, "Mark Files Delete?");
		strcpy(lang->filer_deleting, "deleting...");
		strcpy(lang->filer_deletefailed, "Delete Failed");
		strcpy(lang->filer_renamefailed, "Rename Failed");
		strcpy(lang->filer_pasting, "Pasting...");
		strcpy(lang->filer_pastefailed, "Paste Failed");
		strcpy(lang->filer_direxists, "directory already exists");
		strcpy(lang->filer_newdirfailed, "NewDir Failed");
		strcpy(lang->filer_checkingsize, "Checking Size...");
		strcpy(lang->filer_getsizefailed, "Get Size Failed");
		strcpy(lang->filer_exportfailed, "Export psu Failed");
		strcpy(lang->filer_exportto, "Export to");
		strcpy(lang->filer_importfailed, "Import psu Failed");
		strcpy(lang->filer_importto, "Import to");
		strcpy(lang->filer_keyboard_hint, ":OK ~:Back L1:Left R1:Right START:Enter");
		strcpy(lang->filer_anyfile_hint1, ":OK :Up ~:Mark :RevMark L1:TitleOFF R1:Menu R2:Config");
		strcpy(lang->filer_anyfile_hint2, ":OK :Up ~:Mark :RevMark L1:TitleON  R1:Menu R2:Config");
		strcpy(lang->filer_elffile_hint1, ":OK ~:Cancel :Up :*->ELF");
		strcpy(lang->filer_elffile_hint2, ":OK ~:Cancel :Up :ELF->*");
		strcpy(lang->filer_fntfile_hint1, ":OK ~:Cancel :Up :*->FNT");
		strcpy(lang->filer_fntfile_hint2, ":OK ~:Cancel :Up :FNT->*");
		strcpy(lang->filer_dir_hint, ":OK ~:Cancel :Up Start:Choose");
		strcpy(lang->filer_export_files, "files");
		strcpy(lang->filer_export_header, " num: attr:     size: filename");
		strcpy(lang->filer_import_files, "files");
		strcpy(lang->filer_import_header, " num: attr:     size: filename");
		}
		//config
		{
		strcpy(lang->conf_savefailed, "Save Failed");
		strcpy(lang->conf_saveconfig, "Save Config");
		strcpy(lang->conf_loadconfig, "Load Config");
		strcpy(lang->conf_initializeconfig, "Initialize Config");

		strcpy(lang->conf_setting_button,  "BUTTON SETTING");
		strcpy(lang->conf_setting_screen,  "SCREEN SETTING");
		strcpy(lang->conf_setting_network, "NETWORK SETTING");
		strcpy(lang->conf_setting_font,    "FONT SETTING");
		strcpy(lang->conf_setting_misc,    "MISC SETTING");
		//button
		strcpy(lang->conf_buttonsettinginit, "BUTTON SETTING INIT");
		//screen
		strcpy(lang->conf_background, "BACK GROUND   ");
		strcpy(lang->conf_frame, "FRAME         ");
		strcpy(lang->conf_highlighttext, "HIGHLIGHT TEXT");
		strcpy(lang->conf_normaltext, "NORMAL TEXT   ");
		strcpy(lang->conf_folder, "FOLDER        ");
		strcpy(lang->conf_file, "FILE          ");
		strcpy(lang->conf_ps2save, "PS2 SAVE      ");
		strcpy(lang->conf_elffile, "ELF FILE      ");
		strcpy(lang->conf_interlace, "INTERLACE");
		strcpy(lang->conf_ffmode, "FFMODE");
		strcpy(lang->conf_ffmode_field, "FIELD");
		strcpy(lang->conf_ffmode_frame, "FRAME");
		strcpy(lang->conf_screen_x, "SCREEN X");
		strcpy(lang->conf_screen_y, "SCREEN Y");
		strcpy(lang->conf_flickercontrol, "FLICKER CONTROL");
		strcpy(lang->conf_screensettinginit, "SCREEN SETTING INIT");
		//network
		strcpy(lang->conf_ipaddress, "IP ADDRESS");
		strcpy(lang->conf_netmask, "NETMASK   ");
		strcpy(lang->conf_gateway, "GATEWAY   ");
		strcpy(lang->conf_ipoverwrite, "SAVE IPCONFIG.DAT");
		strcpy(lang->conf_ipsettinginit, "NETWORK SETTING INIT");
		strcpy(lang->conf_ipsaved, "Saved");
		strcpy(lang->conf_ipsavefailed, "Save Failed ");
		//font
		strcpy(lang->conf_AsciiFont, "ASCII FONT");
		strcpy(lang->conf_KanjiFont, "KANJI FONT");
		strcpy(lang->conf_CharMargin, "CHAR MARGIN");
		strcpy(lang->conf_LineMargin, "LINE MARGIN");
		strcpy(lang->conf_FontBold, "FONT BOLD");
		strcpy(lang->conf_AsciiMarginTop,  "ASCII MARGIN TOP ");
		strcpy(lang->conf_AsciiMarginLeft, "ASCII MARGIN LEFT");
		strcpy(lang->conf_KanjiMarginTop,  "KANJI MARGIN TOP ");
		strcpy(lang->conf_KanjiMarginLeft, "KANJI MARGIN LEFT");
		strcpy(lang->conf_fontsettinginit, "FONT SETTING INIT");
		//misc
		strcpy(lang->conf_language, "LANGUAGE");
		strcpy(lang->conf_language_us, "ENGLISH");
		strcpy(lang->conf_language_jp, "{");
		strcpy(lang->conf_timeout, "TIME OUT");
		strcpy(lang->conf_disc_control, "DISC CONTROL");
		strcpy(lang->conf_print_only_filename, "PRINT ONLY FILENAME");
		strcpy(lang->conf_fileicon, "FILEICON");
		strcpy(lang->conf_disc_ps2save_check, "DISC PS2SAVE CHECK");
		strcpy(lang->conf_disc_elf_check, "DISC ELF CHECK");
		strcpy(lang->conf_export_dir, "EXPORT DIR");
		strcpy(lang->conf_miscsettinginit, "MISC SETTING INIT");

		strcpy(lang->conf_ok, "OK");
		strcpy(lang->conf_cancel, "CANCEL");
		strcpy(lang->conf_on, "ON");
		strcpy(lang->conf_off, "OFF");
		strcpy(lang->conf_edit, "Edit");
		strcpy(lang->conf_clear, "Clear");
		strcpy(lang->conf_add, "Add");
		strcpy(lang->conf_away, "Away");
		strcpy(lang->conf_change, "Change");
		strcpy(lang->conf_up, "Up");
		}
	}
	if(l==LANG_JAPANESE){
		//general
		strcpy(lang->gen_ok, "");
		strcpy(lang->gen_cancel, "LZ");
		//main
		{
		strcpy(lang->main_launch_hint, "{^ŋN or \\L[őI");
		strcpy(lang->main_loadhddmod, "HDD NĂ܂");
		strcpy(lang->main_loadftpmod, "FTP NĂ܂");
		strcpy(lang->main_notfound, " ܂");
		strcpy(lang->main_readsystemcnf, "SYSTEM.CNF ǂݍݒ");
		strcpy(lang->main_failed, "SYSTEM.CNF ǂݍݎs܂");
		strcpy(lang->main_nodisc, "fBXN܂");
		strcpy(lang->main_detectingdisc, "fBXNo");
		strcpy(lang->main_stopdisc, "fBXN~");
		}
		//filer
		{
		strcpy(lang->filer_menu_copy, "Rs[");
		strcpy(lang->filer_menu_cut, "؂");
		strcpy(lang->filer_menu_paste, "\\t");
		strcpy(lang->filer_menu_delete, "폜");
		strcpy(lang->filer_menu_rename, "l[");
		strcpy(lang->filer_menu_newdir, "tH_쐬");
		strcpy(lang->filer_menu_getsize, "TCY擾");
		strcpy(lang->filer_menu_exportpsu, "GNX|[g");
		strcpy(lang->filer_menu_importpsu, "C|[g");
		strcpy(lang->filer_overwrite, "㏑܂?");
		strcpy(lang->filer_not_elf, "ELFt@Cł͂܂");
		strcpy(lang->filer_not_fnt, "FNTt@Cł͂܂");
		strcpy(lang->filer_copy_to_clip, "Nbv{[hփRs[܂");
		strcpy(lang->filer_delete, "폜܂?");
		strcpy(lang->filer_deletemarkfiles, "}[Nt@C폜܂?");
		strcpy(lang->filer_deleting, "폜Ă܂");
		strcpy(lang->filer_deletefailed, "폜s܂");
		strcpy(lang->filer_renamefailed, "l[s܂");
		strcpy(lang->filer_pasting, "\\tĂ܂");
		strcpy(lang->filer_pastefailed, "\\ts܂");
		strcpy(lang->filer_direxists, "tH_͊ɑ݂Ă܂");
		strcpy(lang->filer_newdirfailed, "tH_쐬s܂");
		strcpy(lang->filer_checkingsize, "TCYvZĂ܂");
		strcpy(lang->filer_getsizefailed, "TCY擾s܂");
		strcpy(lang->filer_exportfailed, "GNX|[gs܂");
		strcpy(lang->filer_exportto, "GNX|[gꏊ");
		strcpy(lang->filer_importfailed, "C|[gs܂");
		strcpy(lang->filer_importto, "C|[gꏊ");
		strcpy(lang->filer_keyboard_hint, ": ~:폜 L1: R1:E");
		strcpy(lang->filer_anyfile_hint1, ": : ~:}[N :}[N] R1:j[");
		strcpy(lang->filer_anyfile_hint2, ": : ~:}[N :}[N] R1:j[");
		strcpy(lang->filer_elffile_hint1, ": ~:LZ : :*->ELF");
		strcpy(lang->filer_elffile_hint2, ": ~:LZ : :ELF->*");
		strcpy(lang->filer_fntfile_hint1, ": ~:LZ : :*->FNT");
		strcpy(lang->filer_fntfile_hint2, ": ~:LZ : :FNT->*");
		strcpy(lang->filer_dir_hint, ": ~:LZ : Start:tH_I");
		strcpy(lang->filer_export_files, "̃t@C");
		strcpy(lang->filer_export_header, "ԍ: :   TCY: t@C̖O");
		strcpy(lang->filer_import_files, "̃t@C");
		strcpy(lang->filer_import_header, "ԍ: :   TCY: t@C̖O");
		}
		//config
		{
		strcpy(lang->conf_savefailed, "ݒ̕ۑɎs܂");
		strcpy(lang->conf_saveconfig, "ݒۑ");
		strcpy(lang->conf_loadconfig, "ݒǂݍ");
		strcpy(lang->conf_initializeconfig, "ݒ菉");

		strcpy(lang->conf_setting_button,  "`[");
		strcpy(lang->conf_setting_screen,  "ʐݒ");
		strcpy(lang->conf_setting_network, "IPݒ");
		strcpy(lang->conf_setting_font,    "tHgݒ");
		strcpy(lang->conf_setting_misc,    "̑");
		//button
		strcpy(lang->conf_buttonsettinginit, "u`[ݒv");
		//screen
		strcpy(lang->conf_background, "wi̐F      ");
		strcpy(lang->conf_frame, "g̐F        ");
		strcpy(lang->conf_highlighttext, "      ");
		strcpy(lang->conf_normaltext, "          ");
		strcpy(lang->conf_folder, "tH_      ");
		strcpy(lang->conf_file, "t@C      ");
		strcpy(lang->conf_ps2save, "PS2 Z[u    ");
		strcpy(lang->conf_elffile, "ELF t@C  ");
		strcpy(lang->conf_screen_x, "ʈʒu X");
		strcpy(lang->conf_screen_y, "ʈʒu Y");
		strcpy(lang->conf_interlace, "C^[[X");
		strcpy(lang->conf_ffmode, "FFMODE");
		strcpy(lang->conf_ffmode_field, "FIELD");
		strcpy(lang->conf_ffmode_frame, "FRAME");
		strcpy(lang->conf_flickercontrol, "tbJ[");
		strcpy(lang->conf_screensettinginit, "uʐݒv");
		//network
		strcpy(lang->conf_ipaddress, "IPAhX  ");
		strcpy(lang->conf_netmask, "lbg}XN");
		strcpy(lang->conf_gateway, "Q[gEFC");
		strcpy(lang->conf_ipoverwrite, "IPCONFIG.DAT㏑ۑ");
		strcpy(lang->conf_ipsettinginit, "uIPݒv");
		strcpy(lang->conf_ipsaved, "ۑ܂");
		strcpy(lang->conf_ipsavefailed, "ۑs܂ ");
		//font
		strcpy(lang->conf_AsciiFont, "AXL[tHg");
		strcpy(lang->conf_KanjiFont, "tHg    ");
		strcpy(lang->conf_CharMargin, "̊Ԋu");
		strcpy(lang->conf_LineMargin, "s̊Ԋu  ");
		strcpy(lang->conf_FontBold, "ɂ");
		strcpy(lang->conf_AsciiMarginTop, "AXL[tHg̏̊Ԋu");
		strcpy(lang->conf_AsciiMarginLeft, "AXL[tHg̍̊Ԋu");
		strcpy(lang->conf_KanjiMarginTop, "tHg̏̊Ԋu");
		strcpy(lang->conf_KanjiMarginLeft, "tHg̍̊Ԋu");
		strcpy(lang->conf_fontsettinginit, "utHgݒv");
		//misc
		strcpy(lang->conf_language, "LANGUAGE");
		strcpy(lang->conf_language_us, "ENGLISH");
		strcpy(lang->conf_language_jp, "{");
		strcpy(lang->conf_timeout, "I[g[h܂ł̕b");
		strcpy(lang->conf_disc_control, "fBXN~");
		strcpy(lang->conf_print_only_filename, "`[ACet@Ĉ݂ɂ");
		strcpy(lang->conf_fileicon, "FileBrowser̃ACR");
		strcpy(lang->conf_disc_ps2save_check, "CD/DVD̂ƂZ[uf[^ׂ");
		strcpy(lang->conf_disc_elf_check, "CD/DVD̂ƂELFׂ");
		strcpy(lang->conf_export_dir, "GNX|[gtH_");
		strcpy(lang->conf_miscsettinginit, "ȗݒv");

		strcpy(lang->conf_ok, "ۑĖ߂");
		strcpy(lang->conf_cancel, "LZ");
		strcpy(lang->conf_on, "ON");
		strcpy(lang->conf_off, "OFF");
		strcpy(lang->conf_edit, "ҏW");
		strcpy(lang->conf_clear, "폜");
		strcpy(lang->conf_add, "₷");
		strcpy(lang->conf_away, "炷");
		strcpy(lang->conf_change, "ύX");
		strcpy(lang->conf_up, "");
		}
	}
}
